<?php
/**
 * DeleteSpecificApi
 * PHP version 5
 *
 * @category Class
 * @package  Boxx\Ai\Upload
 * @author   boxx Codegen team
 * @link     https://github.com/boxx-api/boxx-codegen
 */

/**
 * Upload and Delete Data API
 *
 * Boxx.ai's customer, product and interaction data ingestion sdk
 *
 * OpenAPI spec version: 1.4.0
 * Contact: aida@boxx.ai
 * Generated by: https://github.com/boxx-api/boxx-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the boxx code generator program.
 * https://github.com/boxx-api/boxx-codegen
 * Do not edit the class manually.
 */

namespace Boxx\Ai\Upload\Api;

use \Boxx\Ai\Upload\ApiClient;
use \Boxx\Ai\Upload\ApiException;
use \Boxx\Ai\Upload\Configuration;
use \Boxx\Ai\Upload\ObjectSerializer;

/**
 * DeleteSpecificApi Class Doc Comment
 *
 * @category Class
 * @package  Boxx\Ai\Upload
 * @author   boxx Codegen team
 * @link     https://github.com/boxx-api/boxx-codegen
 */
class DeleteSpecificApi
{
    /**
     * API Client
     *
     * @var \Boxx\Ai\Upload\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \Boxx\Ai\Upload\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\Boxx\Ai\Upload\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \Boxx\Ai\Upload\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \Boxx\Ai\Upload\ApiClient $apiClient set the API client
     *
     * @return DeleteSpecificApi
     */
    public function setApiClient(\Boxx\Ai\Upload\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation apiDataDeleteDelete
     *
     * Delete selected documents
     *
     * @param \Boxx\Ai\Upload\Model\RequestData3 $request_data request data (required)
     * @throws \Boxx\Ai\Upload\ApiException on non-2xx response
     * @return \Boxx\Ai\Upload\Model\InlineResponse2001
     */
    public function apiDataDeleteDelete($request_data)
    {
        list($response) = $this->apiDataDeleteDeleteWithHttpInfo($request_data);
        return $response;
    }

    /**
     * Operation apiDataDeleteDeleteWithHttpInfo
     *
     * Delete selected documents
     *
     * @param \Boxx\Ai\Upload\Model\RequestData3 $request_data request data (required)
     * @throws \Boxx\Ai\Upload\ApiException on non-2xx response
     * @return array of \Boxx\Ai\Upload\Model\InlineResponse2001, HTTP status code, HTTP response headers (array of strings)
     */
    public function apiDataDeleteDeleteWithHttpInfo($request_data)
    {
        // verify the required parameter 'request_data' is set
        if ($request_data === null) {
            throw new \InvalidArgumentException('Missing the required parameter $request_data when calling apiDataDeleteDelete');
        }
        // parse inputs
        $resourcePath = "/api/data/delete/";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);

        // body params
        $_tempBody = null;
        if (isset($request_data)) {
            $_tempBody = $request_data;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'DELETE',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Boxx\Ai\Upload\Model\InlineResponse2001',
                '/api/data/delete/'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Boxx\Ai\Upload\Model\InlineResponse2001', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxx\Ai\Upload\Model\InlineResponse2001', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxx\Ai\Upload\Model\InlineResponse4001', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 401:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxx\Ai\Upload\Model\InlineResponse4001', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 405:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxx\Ai\Upload\Model\InlineResponse4001', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
